=== debian/changelog ===
lammps (20210122~gita77bb+ds1-2) unstable; urgency=medium

  * [0d859c3] Compile against vtk9
  * [c332a91] Ignore quilt dir
  * [71bc0f1] Ignore debian/files

 -- Anton Gladky <gladk@debian.org>  Tue, 26 Jan 2021 19:41:12 +0100

lammps (20210122~gita77bb+ds1-1) unstable; urgency=medium

  * [0fdcea2] Add gitlab-ci.yml
  * [27f8ce0] Update get_orig script
  * [237ce88] Update gitlab-ci.yml
  * [673a7c7] New upstream version 0~20210122.gita77bb3073
  * [a64d2c8] Refresh patches
  * [97c9689] Update d-files
  * [72d1d2f] Add sphinxdoc

 -- Anton Gladky <gladk@debian.org>  Sun, 24 Jan 2021 20:57:55 +0100
