=== debian/tests/control ===
Tests: crack dipole ellipse flow friction hugo 
Depends: lammps
Restrictions: allow-stderr
